
import ConfigParser
import os
import os.path


class Configurator:

    def __init__(self, main_file):
        self.config = ConfigParser.ConfigParser()
        self.main_file = main_file
        

    def add(self, package_name):    
        package = __import__(package_name)
        components = package_name.split('.')
        for comp in components[1:]:
            package = getattr(package, comp)
        package_paths = package.__path__
        module_name = package_name.split('.')[-1]
        for package_path in package_paths:
            config_filename = os.path.join(package_path, module_name + ".config")
            self.config.read(config_filename)


    def read_main(self):
        self.config.read(self.main_file)

        # default data_dir for quick start        
        if not self.config.has_option("DEFAULT", "data_dir"):
            this_directory = os.path.dirname(__file__)
            abs_path = os.path.abspath(os.path.join(this_directory, "../data"))
            self.config.set("DEFAULT", "data_dir", abs_path + os.sep)

        # default lfs_root
        if not self.config.has_option("DEFAULT", "lfs_root"):
            data_dir = self.config.get("DEFAULT", "data_dir")
            self.config.set("DEFAULT", "lfs_root", os.path.join(data_dir, "lfs") + os.sep)
            

    def get(self, section, key):
        return self.config.get(section, key)

        
    def getint(self, section, key):
        return self.config.getint(section, key)
